<?php
/**
 * @Copyright
 * @package     Field - license check
 * @author      anton {@link http://www.dibuxo.com}
 * @version     Joomla! 3 - 4.0.124
 * @date        Created on 09-02-2019
 * @link        Project Site {@link http://jtotal.org}
 *
 * @license GNU/GPL
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

defined('JPATH_PLATFORM') or die;

class JFormFieldJtotalLicenseCheck extends JFormField
{
    protected $type = 'jtotallicensecheck';

    public $tiempo = '';
    public $error = array();

    protected function getLabel(){
        $mode = $this->element['mode'];
        if($mode == 'dashboard'){

            return "<strong>License</strong>";
        }
        //return "<strong>License</strong>";
    }

    protected function getInput()
    {

        $session = JFactory::getSession();

        $field_set = $this->form->getFieldset();
        $params = $this->form->getValue('params');
     
        $license_email = $field_set['jform_params_jtotal_email']->value;
        $license_key = $field_set['jform_params_jtotal_key']->value;

        $s2sv3_email = $field_set['jform_params_jtotal_license']->value;
        
        if($license_email == ''){
            if($s2sv3_email != ''){
                $license_email = $s2sv3_email;
                $license_key = 'SOCIAL2SV3';
            } 
        }


        $valida_sesion = $session->get('jtotallicensecheck');

        $this->tiempo = '';
        $field_value = '';

        /*******test********/
        //$session->set('JTlicensecheck',0);
        /*******test********/

        $valida = $this->_checkLicense($license_email, $license_key);

        if($valida){
            /*PRO*/
            $field_value .= $this->pro();
         }else{
            /*LITE*/
            $field_value .= $this->lite();
        }


        //$field_set = $this->form->getFieldset();
        $field_value .= "";

        if(count($this->error)>=1){
            //process error
            $field_value .= '<div class="alert alert-danger">';

            foreach ($this->error as $key => $value) {
                echo '<br>';
                 $field_value .= '<i class="fa fa-exclamation-circle"></i> '.$value;
            }

            $field_value .= '</div>';
        }

        $mode = $this->element['mode'];
        if($mode == 'dashboard'){

            if(!$session->get('JTlicensecheck')){
                $session->set('JTlicensecheck',0);
            }
            if($session->get('JTlicensecheck')==1){
                return '<h6 class="text-success"><i class="fas fa-unlock"></i> '.JText::_('JTOTAL_LICENSE_OK_ENJOY').'</h6>';
            }else{

                $lite_dashboard = '<h6 class="text-warning"><i class="fas fa-lock"></i> ';

                $lite_dashboard .= 'Social2s '.JText::_('JTOTAL_LICENSE_LITE_H1');
                $lite_dashboard .= '</h6>';

                return $lite_dashboard;
            }
        }



        return $field_value;
    }


    private function _checkLicense($email, $key){

        $params = $this->form->getValue('params');

        $session = JFactory::getSession();

        if(!$session->get('JTkeycheck')){
            $session->set('JTkeycheck',$key);
        }
        if(!$session->get('JTemailcheck')){
            $session->set('JTemailcheck',$email);
        }
        if(!$session->get('JTlicensecheck')){
            $session->set('JTlicensecheck',0);
        }


        $valida = false;

        //CHECK EMPTY EMAIL AND JKEY
        if($email=='' || $key==''){
            $session->set('JTlicensecheck', 0);
            //$session->set('JTkeycheck',$key);
            $valida = false;
        }else{

            $key_session = $session->get('JTkeycheck');
            $email_session = $session->get('JTemailcheck');
            $license_check =  $session->get('JTlicensecheck');

            if($key_session == $key && $email_session ==$email){
                if($license_check == 1){
                    //EVERYTHINK IS OK...
                    return true;
                }
            }


            //KEY != SESSION
            if($key_session != $key || $email_session !=$email){
                $session->set('JTlicensecheck', 0);
                //$session->set('JTkeycheck',$key);

                if($this->_checkHome($email, $key)===true){
                    $session->set('JTlicensecheck', 1);
                    $key_session = $session->set('JTkeycheck',$key);
                    $email_session = $session->set('JTemailcheck',$email);
                    //$jt_tiempo = $session->set('JTtimeleft',$this->tiempo);

                    $valida = true;
                }else{
                    $session->set('JTlicensecheck', 0); 
                    $valida = false;
                }
            }else{

               //var_dump('</br>key_session == key ');
                if($session->get('JTlicensecheck') == 1){
                    //var_dump('</br>JTlicensecheck == 1 ');
                    $valida = true;
                }else{
                    //var_dump('</br>JTlicensecheck == 0 ');
                    if($this->_checkHome($email, $key)===true){

                        $session->set('JTlicensecheck', 1);
                        $key_session = $session->set('JTkeycheck',$key);
                        $email_session = $session->set('JTemailcheck',$email);
                        //$jt_tiempo = $session->set('JTtimeleft',$this->tiempo);

                        $valida = true;
                    }else{
                        $valida = false;
                    }
                }
            }
        }
        return $valida;
    }

    private function _checkHome($email, $key){
        
        //TEST
        //$url_check = 'http://localhost/online/users_jtotal/index.php?option=com_jtcontrol&tmpl=component&view=jtcheck&email='.$email.'&key='.$key.'&product=1';
        
        //REAL
        $url_check = 'https://users.jtotal.org/index.php?option=com_jtcontrol&tmpl=component&view=jtcheck&email='.$email.'&key='.$key.'&product=2';
        
        $session = JFactory::getSession();

        //CURL
        //var_dump(function_exists('curl_init'));
        if(function_exists('curl_init')){
            $session->set('jtlicense_validation:', 'CURL');
            $checkHomeCurl = $this->_checkHomeCurl($url_check);
            return $checkHomeCurl;
        }else{
        //CURL_FALLBACK
            $session->set('jtlicense_validation:', 'fsockopen');
            return $this->_checkHomeCurl_fallback($url_check);
        }
    }


    public function _checkHomeCurl($url_check){

        $curl_response = curl_init($url_check);
        curl_setopt($curl_response, CURLOPT_HEADER, 0);
        curl_setopt($curl_response, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl_response, CURLOPT_NOSIGNAL, 1);
        curl_setopt($curl_response, CURLOPT_CONNECTTIMEOUT, 5);
        $response = curl_exec($curl_response);

        $session = JFactory::getSession();
        //echo "</br>la respuesta es:".$response;
        //
        $response = json_decode($response);

        //response == success
        if(isset($response->success)){
            if($response->data == "OK"){
                $session->set('jtotallicensecheck', 1);
                $this->tiempo = $response->message->tiempo;
                $this->error[] = 'Data OK';
                return true;
            }else{
                $session->set('jtotallicensecheck', 0);
                $this->error[] = 'Data error';
                return false;
            } 
        }else{
            $this->error[] = 'Error receiving data';
            return false;
        }
    }


    private function _checkHomeCurl_fallback($url){

        $session = JFactory::getSession();
        $response = $this->rest_helper($url);
        $response = json_decode($response);

        //response == success
        if(isset($response->success)){
            if($response->data == "OK"){
                $session->set('jtotallicensecheck', 1);
                $this->tiempo = $response->message->tiempo;
                return true;
            }else{
                $session->set('jtotallicensecheck', 0);
                return false;
            } 
        }else{
            $this->error[] = 'Error receiving data';
            return false;
        }
    }


    function rest_helper($url, $params = null, $verb = 'GET', $format = 'html')
    {
      $cparams = array(
        'http' => array(
          'method' => $verb,
          'ignore_errors' => true
        )
      );
      if ($params !== null) {
        $params = http_build_query($params);
        if ($verb == 'POST') {
          $cparams['http']['content'] = $params;
        } else {
          $url .= '?' . $params;
        }
      }

      $context = stream_context_create($cparams);
      $fp = fopen($url, 'rb', false, $context);
      if (!$fp) {
        $res = false;
      } else {
        $res = stream_get_contents($fp);
      }

      if ($res === false) {
        throw new Exception("$verb $url failed: $php_errormsg");
      }

      switch ($format) {
        case 'json':
          $r = json_decode($res);
          if ($r === null) {
            throw new Exception("failed to decode $res as json");
          }
          return $r;
        case 'html':
          $r = $res;
          if ($r === null) {
            throw new Exception("failed to decode $res as json");
          }
          return $r;
        case 'xml':
          $r = simplexml_load_string($res);
          if ($r === null) {
            throw new Exception("failed to decode $res as xml");
          }
          return $r;
      }
      return $res;
    }


    private function dateDiff($start, $end) { 
        $start_ts = strtotime($start);
        $end_ts = strtotime($end);
        $diff = $end_ts - $start_ts;
        return intval(round($diff / 3600)/24);
    }


    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/
    /***************************************/





    private function lite(){

        $module_id = $this->form->getValue('id');
        $params = $this->form->getValue('params');

        if($params !== NULL){
            //$this->form->setValue('pfeedcomments','0');
            $params->generate_thumbs = '0';
            $params->force_itemid = '0';
            $params->cat_itemid_based = '0';
            $params->category_as_item = '0';
            $params->show_front = 'show';
        }else{
            return $this->mensajeLITE();
        }

        $params->jtotal_license_check = 0;

        //consulta
        $reparams = $this->form->getValue('params');

        $encode_params = json_encode($reparams);

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        // Build the query
        $query->update('#__modules AS a');
        $query->set('a.params = ' . $db->quote((string)$encode_params));
        $query->where('a.id = '.$module_id);

        // Execute the query
        $db->setQuery($query);
        
        // Execute the query
        $db->setQuery($query);
        
        $jversion = new JVersion();
        if($jversion->getShortVersion() >= "3.0"){
            //v3
            $db->query();
        }else{
            //v4
            $db->execute();
        }



        return $this->mensajeLITE();


    }

    private function pro(){

            $count_error = 0;

            $field_value='';

            $field_value.='
            <div class="jtotal_license_ok alert alert-success">';
                        $field_value.= '<div class="span9 col-sm-9 text-center">';
                    
                    $field_value.= '<br>';

                    $field_value.= '<h1 class="text-success"><i class="fas fa-unlock"></i> '.JText::_('JTOTAL_LICENSE_OK_ENJOY').'</h1>';
                    $field_value.= '<img src="'.JURI::root().'modules/mod_visual_menu/images/logo_footer_100.png" width="150"/>';
                    $field_value.= '<br><br>';

                    $field_value.= '<a class="btn btn-info" href="mailto:support@jtotal.org"><strong>'.JText::_('JTOTAL_LICENSE_SUPPORT').'</strong><br></a>  ';

                    $field_value.= '<a class="btn btn-success"><strong>'.JText::_('JTOTAL_LICENSE_REVIEW').'</strong><br></a>';

                    $field_value.='</div>';
                  

                    $field_value.= '<div class="span3 col-sm-3">';
                    if($this->tiempo){
                        $field_value.= '<i class="fas fa-chess-knight fa-3x"></i>
                        '.$this->tiempo.' '.JText::_('JTOTAL_LICENSE_TIME').'
                        
                        <div class="clearfix"></div>';
                    }





                    /*
                    //form activate
                    $module_id = $this->form->getValue('id');

                    //consulta
                    $reparams = $this->form->getValue('params');

                    $encode_params = json_encode($reparams);

                    $db = JFactory::getDBO();
                    $query = $db->getQuery(true);
                    // Build the query
                    $query->update('#__modules AS a');
                    $query->set('a.params = ' . $db->quote((string)$encode_params));
                    $query->where('a.id = '.$module_id);

                    // Execute the query
                    $db->setQuery($query);
                    $db->query();
                    */

                    $params = $this->form->getValue('params');

                    $params->jtotal_license_check = 1;

                        
     
            $field_value.= '</div><div class="clearfix"></div>';

           
                               
            

            $field_value.= '<input type="hidden" class="jtotal_license_check" name="jtotal_license_check_js" value="1"/>';

            return $field_value;

    }

    private function mensajeLITE(){

        $module_id = $this->form->getValue('id');

        $params = $this->form->getValue('params');


        $mensaje='';

        $mensaje.= '<div class="alert alert-danger">

            <div class="col-sm-9 text-center">';

            $mensaje.= '<img src="'.JURI::root().'modules/mod_visual_menu/images/logo_footer_100.png"/>';

            $mensaje.= '<h1>'.JText::_('JTOTAL_LICENSE_LITE_H1').'</h1>';
            $mensaje.= '<h3>'.JText::_('JTOTAL_LICENSE_LITE_MODULE_HEADER').'</h3>';
            $mensaje.= '<h6>'.JText::_('JTOTAL_LICENSE_LITE_HELPUS').'</h6>';
            $mensaje.= '<i class="far fa-heart fa-2x fa-fw" aria-hidden="true"></i>';
            $mensaje.= '<i class="far fa-heart fa-2x fa-fw" aria-hidden="true"></i>';
            $mensaje.= '<i class="far fa-heart fa-2x fa-fw" aria-hidden="true"></i>';
            $mensaje.= '<br>';
            $mensaje.= '<div class="clearfix"></div>';
            $mensaje.= '<br>';


            $mensaje.= '  <a class="btn btn-success" href="https://sites.fastspring.com/dibuxo/product/jtotal"><strong>'.JText::_('JTOTAL_LICENSE_BUY').'</strong><br>
                        <small>'.JText::_('JTOTAL_LICENSE_BUY_AND').'</small>
                    </a>';

            $mensaje.= '  <a class="btn btn-info"><strong>'.JText::_('JTOTAL_LICENSE_REVIEW').'</strong><br>
                        <small>'.JText::_('JTOTAL_LICENSE_REVIEW_AND').'</small>
                    </a>';


        $mensaje.= '</div>';
        $mensaje.= '<div class="col-sm-3 text-center">';
        $mensaje.= '<img src="'.JURI::root().'modules/mod_pfeed/assets/jtotal_portada.png" width="100"/>';
        $mensaje.= '</div>
                    <div class="clearfix"></div>
                    </div>';

        $mensaje.= ' <input type="hidden" class="jtotal_license_check" name="jtotal_license_check_js" value="0"/>';


        return $mensaje;
    }


}
