<?php
/**
 * @Copyright
 * @package     Field - license check
 * @author      anton {@link http://www.dibuxo.com}
 * @version     Joomla! 3.3 - 1.0.25
 * @date        Created on 30-06-2014
 * @link        Project Site {@link http://store.dibuxo.com}
 *
 * @license GNU/GPL
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

defined('JPATH_PLATFORM') or die;

class JFormFieldvisualmenulicensecheck extends JFormField
{
    protected $type = 'visualmenulicensecheck';

    protected function getLabel(){
        return "<strong>License</strong>";
    }

    protected function getInput()
    {
        $field_set = $this->form->getFieldset();
        $license_email = $field_set['jform_params_visualmenu_license_email']->value;

        //sesion para no llamar cada vez
        $session = JFactory::getSession();
        $valida_sesion = $session->get('vm_licensecheck');
        //var_dump($valida_sesion);

        $valida = $this->_checkLicense($license_email);

        if($valida){

            $field_value='<div class="alert alert-success">'.JText::_('MOD_VISUAL_MENU_FIELD_LICENSE_OK').'</div>';
        
         }else{

            //mensaje de alerta y compra
            // Get the params and set the new values
            /*LITE*/
            $params = $this->form->getValue('params');
            $params->generate_thumbs = '0';
            $params->force_itemid = '0';
            $params->cat_itemid_based = '0';
            $params->category_as_item = '0';
            $params->show_front = 'show';
            
 
            $reparams = $this->form->getValue('params');

            $current_module = $this->form->getValue('id');

            //var_dump($current_module);
    
            $encode_params = json_encode($reparams);
            $db = JFactory::getDBO();
            $query = $db->getQuery(true);
            // Build the query
            $query->update('#__modules AS a');
            $query->set('a.params = ' . $db->quote((string)$encode_params));
            $query->where('a.id = "'.$current_module.'"');

            // Execute the query
            $db->setQuery($query);
            $db->query();

            //alerta LITE
            $field_value='<div class="alert alert-error"><h4>'.JText::_('MOD_VISUAL_MENU_DONATE').'</h4>'.JText::_('MOD_VISUAL_MENU_DONATE_DESC').'</div>';
        }

        //$field_set = $this->form->getFieldset();
        $field_value .= "";

        return $field_value;
    }

    private function _checkLicense($email){

        $params = $this->form->getValue('params');

        $session = JFactory::getSession();
        if(!$session->get('vm_emailcheck')){
            $session->set('vm_emailcheck',$email);
        }
        if(!$session->get('vm_licensecheck')){
            $session->set('vm_licensecheck',0);
        }

        $valida = false;

        if($email==""){
            //$valida = false;
            $session->set('vm_licensecheck', 0);
            $session->set('vm_emailcheck',$email);
        }else{
            $email_session = $session->get('vm_emailcheck');

            if($email_session != $email){
                $session->set('vm_licensecheck', 0);
                $session->set('vm_emailcheck',$email);

                if($this->_checkHome($email)){

                    $session->set('vm_licensecheck', 1);
                    $valida = true;
                }else{
                    $session->set('vm_licensecheck', 0); 
                    $valida = false;
                }
            }else{

                if($session->get('vm_licensecheck') == 1){
                    $valida = true;
                }else{
                    if($this->_checkHome($email)){
                        $valida = true;
                    }else{
                        $valida = false;
                    }
                }
            }
        }
        return $valida;
    }

    private function _checkHome($email){

        $url_fopen = ini_get('allow_url_fopen');
        if(function_exists('curl_init') && !empty($url_fopen)){

            $url_check = 'http://soft.dibuxo.com/licenses/visualmenu/validation.php?email='.$email;
            $curl_response = curl_init($url_check);
            curl_setopt($curl_response, CURLOPT_HEADER, 0);
            curl_setopt($curl_response, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl_response, CURLOPT_NOSIGNAL, 1);
            curl_setopt($curl_response, CURLOPT_CONNECTTIMEOUT, 5);
            $response = curl_exec($curl_response);

            $session = JFactory::getSession();
            //echo "</br>la respuesta es:".$response;
            if($response == "OK"){
                //echo "</br>respuesta OK";
                return true;
            }else{
                //echo "</br>respuesta KO";
                $session->set('vm_licensecheck', 0);
                return false;
            }
        }else{
            echo '<div class="alert alert-error">'.JText::_('MOD_VISUAL_MENU_ERROR_VALIDATING').'</div>';
            return false;
        }
    }

}
