<?php

/**
 * @Copyright Copyright (C) 2010 jtotal . All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @link https://www.jtotal.org
*/

use Joomla\CMS\Filter\OutputFilter;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;

// no direct access
defined('_JEXEC') or die;

$module_id = $params->get('module_id', 'visual_menu_module_bs4');


$css            = $params->get('css', '');
$display_titles = $params->get('display_titles', '1');
$show_date      = $params->get('show_date', '0');
$show_category  = $params->get('show_category', '0');
$default_image  = $params->get('default_image');
$show_back      = $params->get('show_back', '0');
$show_introtext = $params->get('show_introtext', '0');


//BOOTRAP
$visual_menu_bs_on = $params->get('visual_menu_bs_on', '1');

$bs_lg = $params->get('bs_lg', '2');
$bs_md = $params->get('bs_md', '3');
$bs_sm = $params->get('bs_sm', '4');
$bs_xs = $params->get('bs_xs', '6');


$visual_menu_maxh_bs = $params->get('visual_menu_maxh_bs', '0');

$bs_maxh_lg = $params->get('bs_maxh_lg', '');
$bs_maxh_md = $params->get('bs_maxh_md', '');
$bs_maxh_sm = $params->get('bs_maxh_sm', '');
$bs_maxh_xs = $params->get('bs_maxh_xs', '');

$vm_zoom_f = $params->get('vm_zoom', '1');


/* TEST colums
    $col_bs_lg = 12/$bs_lg;
    $col_bs_md = 12/$bs_md;
    $col_bs_sm = 12/$bs_sm;
    $col_bs_xs = 12/$bs_xs;
*/
?>

<style>
    <?php
    echo $css;

    if ($visual_menu_maxh_bs) {
        if ($bs_maxh_xs) {
            echo '.vm_thumbnail{
                max-height: ' . $bs_maxh_xs . 'px;
            }';
        }

        //768
        echo '@media (min-width: 768px){';
        if ($bs_maxh_sm) {
            echo '.vm_thumbnail{
                    max-height: ' . $bs_maxh_sm . 'px;
                }';
        }
        echo '}';

        //992
        echo '@media (min-width: 992px){';
        if ($bs_maxh_md) {
            echo '.vm_thumbnail{
                    max-height: ' . $bs_maxh_md . 'px;
                }';
        }
        echo '}';

        //1200
        echo '@media (min-width: 1200px){';
        if ($bs_maxh_lg) {
            echo '.menu_elements_wrapper .vm_thumbnail{
                    max-height: ' . $bs_maxh_lg . 'px;
                }';
        }
        echo '}';
    }


    if ($vm_zoom_f != 1) {
        $vm_zoom = $vm_zoom_f + 100;
        $v_zoom_left = $vm_zoom_f / 2;
        echo '.menu_elements_wrapper div.vm_img_wrapper img{
            max-width: ' . $vm_zoom . '%;
            width: ' . $vm_zoom . '%;
            left: -' . $v_zoom_left . '%;
        }';
    }

    if ($img_position == 'overlay') {
        echo '.vm_image_overlay{
            opacity:' . $img_opacity . ';
        }';
        echo '.menu_elements_wrapper:hover .vm_image_overlay{
            opacity:' . $img_opacity_end . ';
        }';
    }



    ?>
</style>



<?php
//SAME Heights for all elements
if ($params->get('visual_menu_sameh_bs', '0')) {
    $vm_sameh = ' h-100';
} else {
    $vm_sameh = ' ';
}
?>




<!-- SUPERWRAPPER -->
<div class="jt_menu_visual_wrapper">

    <!-- wrapper MODULE -->
    <div id="<?php echo $module_id; ?>" class="dx_visual_module vm_bs ">

        <?php
        //$bs_classes = 'col-lg-'.$bs_lg.' col-md-'.$bs_md.'  col-'.$bs_xs;
        $bs_classes = '';
        $bs_masonry = '';

        if ($visual_menu_bs_on) {
            $bs_classes = 'row row-cols-' . $bs_xs .
                ' row-cols-sm-' . $bs_sm .
                ' row-cols-md-' . $bs_md .
                ' row-cols-lg-' . $bs_lg .
                ' g-4';
        }

        if($visual_menu_bs_masonry_on) {
            $bs_masonry = 'data-masonry=\'{"percentPosition": true }\'';
        }
        ?>

        <!-- vm TABLE -->
        <div class="vm_table <?Php echo $bs_classes; ?>" <?Php echo $bs_masonry; ?>>

            <!-- SHOW BACK -->
            <?php if ($show_back) : ?>
                <div class="col">

                    <div class="card menu_elements_wrapper showback <?php echo $vm_sameh; ?> ">
                        <div class="vm_thumbnail">
                            <a href="#" onClick="history.go(-1);return true;">

                                <i class="fas fa-caret-square-left"></i>

                                <h3 class="vm_title">
                                    <?php echo Text::_('MOD_VISUAL_MENU_BACK'); ?>
                                </h3>

                            </a>
                        </div>
                    </div>

                </div>
            <?php endif; ?>



            <!--bucle principal-->
            <!--bucle principal-->
            <!--bucle principal-->
            <?php foreach ($list as $key => $item) : ?>

                <?php

                $keyplus = $key + 1;

                //var_dump($item->link);

                $enlace = $item->link;

 
                if ($use_article_url == 1 && ($item->urls != '')) {

            

                    $urls = json_decode($item->urls);
                    if ($urls->urla != '') {
                        $enlace = $urls->urla;
                    }
                }

 

                $enlace = OutputFilter::ampReplace(htmlspecialchars($enlace, ENT_COMPAT, 'UTF-8', false));
      


                //******************
                //* IMAGE
                //******************

                //* link
                $final_image = '';
                $overlay_image = '';




                if ($item->active) {
                    $final_image .= '<div class="vm_thumbnail   ' . $item->active . ' img_pos_' . $img_position . '">';

                    //echo '<div class="vm_gradient vm_gradient_active"></div>';

                    $vma = '<a class="vm_a ' . $item->active . '">';
                    $vma_img = '<a class="vm_picture_a ' . $item->active . '" aria-label="'.$item->title.'">';
                } else {
                    $final_image .= '<div class="vm_thumbnail img_pos_' . $img_position . '">';

                    //echo '<div class="vm_gradient"></div>';

                    //echo '<a class="vm_a" href="'.$enlace.'">';

                    $vma = '<a class="vm_a" href="' . $enlace . '">';

                    //var_dump($enlace);



                    $vma_img = '<a class="vm_picture_a" href="' . $enlace . '" aria-label="'.$item->title.'">';

              
                }
                //* picture + image
      
                $bs_image_class = 'card-img-' . $img_position;

                if (isset($item->displayImage)) {
                    $final_image .= '<div class="vm_img_wrapper ">';

                    //link
                    $final_image .= $vma_img;


                    $final_image .= '<picture class="vm_picture">';

                    if (isset($item->displayImage['webp'])) {
                        if ($item->displayImage['webp']) {
                            $final_image .= '<source srcset="' . $item->displayImage['path'] . '.webp" type="image/webp" />';
                        }
                    }
             
                    if (isset($item->displayImage['path'])) {
                        $final_image .= '<img class="img-fluid vm_img ' . $bs_image_class . '" ' . $lazy_image . ' 
                            src="' . $item->displayImage['path'] . '.' . $item->displayImage['ext'] . '" ';
                            
                            //alt
                            $altImage = ($item->displayAlt != '') ? $item->displayAlt : $item->title;
                            $final_image .= 'alt="' . $altImage.'"';
                            //size
                            if(isset($item->displayImage['size_string'])) $final_image .= $item->displayImage['size_string'];

                        $final_image .= '/>';

                        $overlay_image = $item->displayImage['path'] . '.' . $item->displayImage['ext'];
                    } else {
                        $final_image .= '<img class="vm_img ' . $bs_image_class . '" ' . $lazy_image . ' src="' . $item->displayImage . '" alt="' . $item->displayAlt . '"/>';
                        $overlay_image = $item->displayImage;
                    }
                
                    //var_dump($item->displayImage);

                    $final_image .= '</picture>';

                    //end link
                    $final_image .= '</a>';

                    //end wrapper
                    $final_image .= '</div>';
                } else {

                    $final_image .= '<div class="vm_img_wrapper">';

                    if ($default_image == null || $default_image == '-1') {
                        $final_image .= '<img src="modules/mod_visual_menu/images/noimage.png" 
                            class="vm_img" alt="vm_noimage" />';
                            
                        $overlay_image = 'modules/mod_visual_menu/images/noimage.png';
                    } else {
                        $final_image .= '<img src="' . URI::base() . 'images/' . $default_image . '" 
                            class="vm_img" alt="' . $item->title . '" />';

                        $overlay_image = URI::base() . 'images/' . $default_image;
                    }

                    $final_image .= '</div>';
                }

                $final_image .= '</div>';

                $overlay_style = '';
                if ($overlay_image) {
                    $overlay_style = 'style="height:100%;background-size: cover; background-image:url(' . $overlay_image . ')"';
                }


                //******************
                //* end IMAGE
                //******************





                $vm_featured = '';
                if ($item->featured) {
                    $vm_featured = ' vm_featured';
                }



                //******************
                //* WRAPPER + CARD
                //******************

                $show_body = true;
                if (!$display_titles && !$show_date && !$show_category && !$show_introtext) {
                    $show_body = false;
                }


                ?>
                <div class="col">

                    <!--  CARD -->
                    <div class="card menu_elements_wrapper <?php echo $vm_featured; ?> <?php echo $vm_sameh; ?> <?php echo $item->active; ?>">


                        <!-- top IMG -->
                        <?php if ($img_position == 'top') echo $final_image; ?>


                        <?php if ($show_body) : ?>

                            <!--  BODY -->
                            <div class="card-body vm_menu_data">


                                <!-- CARD HEADER -->
                                <div class="vm_menu_header">

                                    <!-- titles -->
                                    <?php if ($display_titles) : ?>
                                        <div class="vm_menu_title">
                                            <?php
                                            if($vm_titles_h != 0){
                                                echo '<h' . $vm_titles_h . ' class="vm_title">';
                                                echo $vma . $item->title . '</a>';
                                                echo '</h' . $vm_titles_h . '>';
                                            }else{
                                                echo $vma . $item->title . '</a>';
                                            }
                                            ?>
                                        </div>
                                    <?php endif; ?>

                                    <!-- show date -->
                                    <?php if ($show_date) : ?>
                                        <div class="vm_date">
                                            <small><i class="fas fa-calendar"></i>
                                                <?php echo $item->displayDate; ?>

                                            </small>
                                        </div>
                                    <?php endif; ?>

                                    <!-- show category -->
                                    <?php if ($show_category) : ?>
                                        <div class="vm_category">
                                            <span>
                                                <?php echo $item->category_title; ?>
                                            </span>
                                        </div>
                                    <?php endif; ?>
                                    <!-- end CARD HEADER -->
                                </div>

                                <!-- CARD BODY -->
                                <div class="vm_menu_body">
                                    <!-- introtext -->
                                    <?php if ($show_introtext) : ?>
                                        <div class="vm_introtext">
                                            <span>
                                                <?php echo $item->displayIntrotext; ?>
                                            </span>
                                        </div>
                                    <?php endif; ?>
                                </div>





                                <!-- end BODY -->
                            </div>
                        <?php endif; ?>


                        <?php if ($img_position == 'overlay') : ?>

                            <a class="vm_a_overlay" href="<?php echo $enlace; ?>"></a>

                            <div class="vm_image_overlay" <?php echo $overlay_style; ?>> </div>
                        <?php endif; ?>



                        <!-- FOOTER -->
                        <?php if ($show_readmore && ($item->active != 'active')) : ?>
                            <div class="vm_menu_footer card-footer">
                                <div class="vm_readmore">
                                    <?php
                                    echo '<a class="vm_readmore_a ' . $readmore_class . '" target="' . $show_readmore_target . '" href="' . $enlace . '">';
                                    echo Text::_('MOD_VISUAL_MENU_READMORE');
                                    echo '</a>';
                                    ?>
                                </div>
                            </div>
                        <?php endif; ?>



                        <?php if ($img_position == 'bottom') echo $final_image; ?>

                        <!--  end CARD -->
                    </div>
                    <!--  end COL -->
                </div>


            <?php endforeach; ?>


            <!-- end vm TABLE -->
        </div>

        <!-- end wrapper MODULE -->
    </div>

    <!-- end SUPERWRAPPER -->
</div>